#ifndef DGMAXWELLLOCAL_H_
#define DGMAXWELLLOCAL_H_


#include <deal.II/fe/fe_values.h>
#include <deal.II/fe/fe_system.h>
#include <deal.II/fe/mapping_q1.h>
#include <deal.II/fe/fe_dgq.h>

#include <deal.II/lac/sparse_matrix.h>
#include <deal.II/lac/block_sparse_matrix.h>
#include <deal.II/lac/block_vector.h>

namespace MaxwellProblem {
namespace Assembling{
using namespace dealii;

template<int dim>
class DGMaxwellLocal
{
	public:

	DGMaxwellLocal();

	void assemble_cell_curl(const FEValues<dim> &fe_v,
			FullMatrix<double> 	&cell_curl_matrix) const;

	void assemble_face_curl(const FEFaceValuesBase<dim> &fe_v,
							 const FEFaceValuesBase<dim> &fe_v_neighbor,
							 FullMatrix<double> &cell_curl_matrix,
							 FullMatrix<double> &cell_face_matrix_ext_int,
							 FullMatrix<double> &cell_face_matrix_int_ext,
							 FullMatrix<double> &cell_curl_matrix_neighbor,
							 double				eps,
							 double 			mu,
							 double 			eps_neighbor,
							 double				mu_neighbor) const;

	void assemble_cell_mass_matrices(
			FullMatrix<double> 			&cell_mass_matrix_H,
			FullMatrix<double> 			&cell_mass_matrix_E,
			FEValues<dim>				&fe_v,
			double						eps,
			double						mu) const;

private:

	const FEValuesExtractors::Vector V;

};
}
}

#endif /* DGMAXWELLLOCAL_H_ */
