/*
 * global.h
 *
 *  Created on: Jul 15, 2016
 *      Author: koehler
 */

#ifndef GLOBAL_H_
#define GLOBAL_H_

#include <boost/property_tree/ptree.hpp>
namespace pt = boost::property_tree;

#include <deal.II/base/timer.h>

namespace MaxwellProblem {

/**
 * Namespace in which some configuration variables are stored
 */
namespace global {

/**
 * This object contains all parameters of the config file of this project.
 */
extern pt::ptree config;

/**
 * declaration of timers
 */
extern dealii::Timer 	assemble_timer, setup_timer, solve_timer, rhs_assemble_timer,
						rest_timer, solve_timer_A, solve_timer_B;

}
}

#endif /* GLOBAL_H_ */
