#include "Compare.h"

namespace MaxwellProblem {

template <int dim, typename T>
Compare<dim, T>::Compare(
		unsigned int dir
		)
:
direction(dir)
{
	Assert(dir<=3, ExcNotImplemented());
}

template <int dim, typename T>
bool Compare<dim, T>::operator() (
		const std::pair< Point<dim>, T >	&lhs,
		const std::pair< Point<dim>, T >	&rhs
		)
{
//	for (unsigned i=0; i < dim; ++i)
//		if (lhs.first((direction+(dim-i-1))%dim) != rhs.first((direction+(dim-i-1))%dim))
//			return (lhs.first((direction+(dim-i-1))%dim) < rhs.first((direction+(dim-i-1))%dim));
	for (unsigned i=0; i < dim; ++i)
		if (fabs(lhs.first((direction+(dim-i-1))%dim) - rhs.first((direction+(dim-i-1))%dim)) > 1e-14) // check if both coordinates are equal, otherwise return their comparison.
		{
// 			if (fabs(lhs.first((direction+(dim-i-1))%dim) - rhs.first((direction+(dim-i-1))%dim)) < 1e-10)
// 				std::cout << "Problem!!" << std::endl << fabs(lhs.first((direction+(dim-i-1))%dim) - rhs.first((direction+(dim-i-1))%dim)) << std::endl;
			return (lhs.first((direction+(dim-i-1))%dim) < rhs.first((direction+(dim-i-1))%dim));
		}

	std::cout << "Problem!!" << std::endl << std::endl;
	Assert(false, ExcInternalError());
	return false;
}

template class Compare<3,typename DoFHandler<3>::active_cell_iterator>;

} /* namespace MaxwellProblem */
