#ifndef COMPARE_H_
#define COMPARE_H_

#include <utility>

#include <deal.II/base/exceptions.h>
#include <deal.II/base/point.h>
#include <deal.II/dofs/dof_handler.h>
#include <deal.II/dofs/dof_renumbering.h>
#include <deal.II/dofs/dof_accessor.h>

namespace MaxwellProblem {

using namespace dealii;

template <int dim, typename T>
class Compare {
public:
			Compare		(unsigned int						dir);
	bool	operator()	(const std::pair< Point<dim>, T >	&lhs,
					 	 const std::pair< Point<dim>, T >	&rhs);

private:
	unsigned int	direction;
};

} /* namespace MaxwellProblem */

#endif /* COMPARE_H_ */
